# File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.

from typing import List, Optional
from datetime import date, datetime

from ..._models import BaseModel

__all__ = [
    "PressReferenceRetrieveResponse",
    "Cards",
    "CardsFields",
    "CardsFieldsIdentifier",
    "CardsFieldsActivityEntity",
    "CardsFieldsURL",
    "Properties",
    "PropertiesIdentifier",
    "PropertiesActivityEntity",
    "PropertiesURL",
]


class CardsFieldsIdentifier(BaseModel):
    entity_def_id: str

    uuid: str
    """a wild uuid!"""

    image_id: Optional[str] = None

    permalink: Optional[str] = None

    value: Optional[str] = None


class CardsFieldsActivityEntity(BaseModel):
    entity_def_id: str

    uuid: str
    """a wild uuid!"""

    image_id: Optional[str] = None

    permalink: Optional[str] = None

    value: Optional[str] = None


class CardsFieldsURL(BaseModel):
    label: Optional[str] = None

    value: Optional[str] = None


class CardsFields(BaseModel):
    identifier: CardsFieldsIdentifier
    """
    Every entity in the system has a unique identifier that contains all necessary
    properties to represent it.
    """

    activity_entities: Optional[List[CardsFieldsActivityEntity]] = None
    """Entities mentioned in the press reference"""

    author: Optional[str] = None
    """The author of the press reference"""

    created_at: Optional[datetime] = None

    entity_def_id: Optional[str] = None
    """- press_reference - Press Reference"""

    facet_ids: Optional[List[str]] = None

    posted_on: Optional[date] = None
    """Date when the press reference is posted"""

    publisher: Optional[str] = None
    """The publisher of the press reference"""

    thumbnail_url: Optional[str] = None

    title: Optional[str] = None
    """The title of the press reference"""

    updated_at: Optional[datetime] = None

    url: Optional[CardsFieldsURL] = None
    """An object representing both the url and some labeling text for that url"""

    uuid: Optional[str] = None


class Cards(BaseModel):
    fields: Optional[CardsFields] = None


class PropertiesIdentifier(BaseModel):
    entity_def_id: str

    uuid: str
    """a wild uuid!"""

    image_id: Optional[str] = None

    permalink: Optional[str] = None

    value: Optional[str] = None


class PropertiesActivityEntity(BaseModel):
    entity_def_id: str

    uuid: str
    """a wild uuid!"""

    image_id: Optional[str] = None

    permalink: Optional[str] = None

    value: Optional[str] = None


class PropertiesURL(BaseModel):
    label: Optional[str] = None

    value: Optional[str] = None


class Properties(BaseModel):
    identifier: PropertiesIdentifier
    """
    Every entity in the system has a unique identifier that contains all necessary
    properties to represent it.
    """

    activity_entities: Optional[List[PropertiesActivityEntity]] = None
    """Entities mentioned in the press reference"""

    author: Optional[str] = None
    """The author of the press reference"""

    created_at: Optional[datetime] = None

    entity_def_id: Optional[str] = None
    """- press_reference - Press Reference"""

    facet_ids: Optional[List[str]] = None

    posted_on: Optional[date] = None
    """Date when the press reference is posted"""

    publisher: Optional[str] = None
    """The publisher of the press reference"""

    thumbnail_url: Optional[str] = None

    title: Optional[str] = None
    """The title of the press reference"""

    updated_at: Optional[datetime] = None

    url: Optional[PropertiesURL] = None
    """An object representing both the url and some labeling text for that url"""

    uuid: Optional[str] = None


class PressReferenceRetrieveResponse(BaseModel):
    cards: Optional[Cards] = None

    properties: Optional[Properties] = None
